#include <semaphore.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

// parallel threads that ask for the same resource (i)
// need for a mutual exclusion ==> sol avec un sémaphore s 

sem_t s; //*****************************************************
int i=0;

void * increment(void * arg)
{
	
	// debut section critique
	for(int j=0; j<10000;j++)	
	{
		sem_wait(&s);//*****************************************	
		// debut section critique	
		i++;
		// fin section critique	
		sem_post(&s);//*****************************************
	}	
	printf("the value of i is %d\n",i);
	// fin section critique
	
	pthread_exit (NULL);

}


void main()
{	
	sem_init(&s,0,1);//*********************************************
	pthread_t thread1, thread2, thread3;
	pthread_create (&thread1, NULL, increment, NULL);
	pthread_create (&thread2, NULL, increment, NULL);
	pthread_create (&thread3, NULL, increment, NULL);
	
	pthread_join(thread1, NULL);
	pthread_join(thread2, NULL);
	pthread_join(thread2, NULL);

	pthread_exit (NULL);
}


