#include <semaphore.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

#define N 50

// producteur consommteur tampon borné =N 
// simulation avec N un entier

sem_t mutex, vide, plein;

int Nb_obj=0;

void * produire(void * arg)
{
	int i;	
	for (i=0;i<100;i++){
		//produire objet
		
		sem_wait(&vide);	
		// debut section critique	
		sem_wait(&mutex);	
		Nb_obj++; //déposer objet
		printf("+++prod: état de la liste est Nb_obj= %d\n",Nb_obj);
		// fin section critique
		sem_post(&mutex);	
		sem_post(&plein);
	}
	pthread_exit (NULL);
}

void * consommer(void * arg)
{
	int i;	
	for (i=0;i<100;i++){		//produire objet	
		sem_wait(&plein);	
		// debut section critique	
		sem_wait(&mutex);	
		Nb_obj--; //retirer objet
		printf("---cons: état de la liste est Nb_obj= %d\n",Nb_obj);
		// fin section critique
		sem_post(&mutex);	
		sem_post(&vide);
		// consommer objet

	}
	pthread_exit (NULL);
}


int main()
{
	sem_init(&mutex,0,1);
	sem_init(&vide,0,N);
	sem_init(&plein,0,0);
	
	pthread_t thread1, thread2;

	pthread_create (&thread1, NULL, produire, NULL);
	pthread_create (&thread2, NULL, consommer, NULL);
	
	pthread_join(thread1, NULL);
	pthread_join(thread2, NULL);

	return 0;
}

