#include <semaphore.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

// RDV de 2 threads: sol avec 2 sémaphores

sem_t sem_arrive1, sem_arrive2;

void * p1(void * arg)
{
	printf("1111111 : Thread 1 with id  %lu finished step 1...\n", pthread_self());
	sem_post(&sem_arrive2);//***** ouvrir la barrière pour l'autre processus (le réveiller)
	sem_wait(&sem_arrive1);//***** attendre que l'autre m'ouvre la barrière quand il arrivera
	printf("1111111 : thread 1 with id %lu begins step 2... \n",pthread_self());
	pthread_exit (NULL);
}

void * p2(void * arg)
{
	printf("22222222 : Thread 2 with id  %lu finished step 1...\n", pthread_self());
	sem_post(&sem_arrive1);
	sem_wait(&sem_arrive2);
	printf("22222222 : thread 2 with %lu begins step 2... \n",pthread_self());
	pthread_exit (NULL);
}

void main()
{
	sem_init(&sem_arrive1,0,0);
	sem_init(&sem_arrive2,0,0);
	pthread_t thread_id[2];
	int i;
	pthread_create (&thread_id[0], NULL, p1, NULL);
	pthread_create (&thread_id[1], NULL, p2, NULL);
	for (i=0;i<2;i++)
	pthread_join(thread_id[i], NULL);
	pthread_exit (NULL);
}

