#include <semaphore.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

//

sem_t sem_rdv;
pthread_mutex_t mutex; // protect access to variable "count"
int n=5; //number of processes
int count=0;// nombre de thread qui ont atteint le point de rdv (ont exécuté phase 1)

void * samplefunction(void * arg)
{
	printf("Thread %lu finished step 1...\n", pthread_self());
	
// debut section critique	
	pthread_mutex_lock(&mutex);
	count++;
	if (count==n) sem_post(&sem_rdv); // le dernier thread qui fini step 1 réveille l'un des threads bloqués	
	pthread_mutex_unlock(&mutex);
// fin section critique

	sem_wait(&sem_rdv);// attente 
	sem_post(&sem_rdv);// libération d'un autre thread en attente 

	printf("thread %lu begins step 2... \n",pthread_self());
	pthread_exit (NULL);
}

void main()
{	sem_init(&sem_rdv,0,0);
	pthread_t thread_id[n];
	
	int i;
	for (i=0;i<n;i++)
	pthread_create (&thread_id[i], NULL, &samplefunction, NULL);

	for (i=0;i<n;i++)
	pthread_join(thread_id[i], NULL);
	
	pthread_exit (NULL);
}

