#include <semaphore.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

//Les fonction carre et doubler s'exécutent en parallèle
// ==> besoin d'exclusion mutuelle  ==> sol avec sem

sem_t sem;
long int val=0;

void * fonction(void * arg)
{
	long int i;
	for (i=0;i<1000000;i++)
	{
		sem_wait(&sem);// attend sem devient >0 puis la décrémente***************
		// debut section critique	
		val=val+1;
		// fin section critique
		sem_post(&sem);//incrémente sem et réveille éventuellemet un thread*******
	}	
	printf("thread %lu , val=%lu\n",pthread_self(),val);
	pthread_exit (NULL);
}

int main()
{
	
	if (sem_init(&sem,0,1) != 0)// (&s,0,1) ==> 0: partagé entre les threads d'un même processus*****
    	{
        	printf("\n sem init failed\n");
        	return 1;
    	}
	pthread_t thread1, thread2;
	pthread_create (&thread1, NULL, fonction, NULL);
	pthread_create (&thread2, NULL, fonction, NULL);
	
	pthread_join(thread1, NULL);
	pthread_join(thread2, NULL);
	printf("val final est %lu \n",val);
	sem_destroy(&sem); //*****************************
	return 0;
}

