#include <semaphore.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

///Repeat the execution to discover that the final result is always 300000
//solution with a mutex (mutual exclusion)


//pthread_mutex_t lock=PTHREAD_MUTEX_INITIALIZER;// creation statique************

pthread_mutex_t lock; /// creation dynamique: voir main pout l'initialisation****

int i=0;

void * increment(void * arg)
{
	for(int j=0; j<10000;j++)	
	{
		pthread_mutex_lock(&lock);//Demande de verrou*************
		// debut section critique	
		i++;
		// fin section critique	
		pthread_mutex_unlock(&lock);//Libération du verrou*******
	}	
	printf("the value of i is %d\n",i);
	pthread_exit (NULL);
}

int main()
{
	pthread_t thread1, thread2, thread3;
	if (pthread_mutex_init(&lock, NULL) != 0)//*****************
    	{
        	printf("\n mutex init failed\n");
        	return 1;
    	}
	pthread_create (&thread1, NULL, increment, NULL);
	pthread_create (&thread2, NULL, increment, NULL);
	pthread_create (&thread3, NULL, increment, NULL);
	
	pthread_join(thread1, NULL);
	pthread_join(thread2, NULL);
	pthread_join(thread2, NULL);
	
	pthread_mutex_destroy(&lock); //*****************************
	
	pthread_exit (NULL);
}




