#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

int i;
int verrou=0;

void MutexBegin()
{
	while (TAS(&verrou));
}

void Mutexfinish()
{
	verrou=0;
}

// software implementation of TAS ==> doit être atomique. Mais ici elle ne l'est pas
int TAS (int *val)
{ 
	int temp;
	temp= *val;		//implantée de manière atomique
	*val = 1;
	return temp;
}

void * positif (void * arg)
{	
	MutexBegin();	
	i=10;
	printf("i=%d, thread positif gagne ++++++++++ \n",i);
	Mutexfinish();
	pthread_exit(NULL);
}

void * negatif (void * arg)
{	
	MutexBegin();	
	i=-10;
	printf("i=%d, thread negatif gagne ----------- \n",i);
	Mutexfinish();
	pthread_exit(NULL);
}

void main()
{
	pthread_t thread1, thread2;
	pthread_create (&thread1, NULL, positif, NULL);
	pthread_create (&thread2, NULL, negatif, NULL);
	pthread_exit(NULL);
}

