#include <semaphore.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

//supprimer l'utilisaton de la var lock pou voir des incohérences du résultat

// ==> besoin d'exclusion mutuelle  ==> sol avec un mutex

//pthread_mutex_t lock=PTHREAD_MUTEX_INITIALIZER;// creation statique************

pthread_mutex_t lock; /// creation dynamique: voir main pout l'initialisation****

long int val=0;

void * fonction(void * arg)
{
	long int i;
	for (i=0;i<1000000;i++)
	{
		pthread_mutex_lock(&lock);//Demande de verrou*************
		// debut section critique	
		val=val+1;
		// fin section critique
		pthread_mutex_unlock(&lock);//Libération du verrou*******
	}	
	printf("thread %lu , val=%lu\n",pthread_self(),val);
	pthread_exit (NULL);
}

int main()
{
	if (pthread_mutex_init(&lock, NULL) != 0)//*****************
    	{
        	printf("\n mutex init failed\n");
        	return 1;
    	}
	pthread_t thread1, thread2;
	pthread_create (&thread1, NULL, fonction, NULL);
	pthread_create (&thread2, NULL, fonction, NULL);
	
	pthread_join(thread1, NULL);
	pthread_join(thread2, NULL);
	printf("val final est %lu \n",val);
	pthread_mutex_destroy(&lock); //*****************************
	return 0;
}

