#include<errno.h>
#include <stdlib.h>
#include<stdio.h>
#include<unistd.h> /*contient l'appel système pipe */
void main (void) {
	int tube[2]; /* deux descripteurs de pipe : tube[0] --> lecture (fils) et tube[1] --> écriture (père) */
	printf("\navant:  tube[0]=%d et tube[1]=%d",tube[0],tube[1]);	
	char car1; /* caractère de l'alphabet*/
	int ret; /*Valeur de retour du fils*/
	pipe(tube); /* Création du tube -- tampon interne */
	printf("\n après: tube[0]=%d et tube[1]=%d\n",tube[0],tube[1]);
	switch (fork()) {/*Création d'un processus fils*/
		case -1 : { perror("impossible de créer un processus"); exit(2); }
		case 0 :{ 
				close(tube[1]); /* le fils ne peut écrire dans le tube*/
				while (read(tube[0], &car1,1)>0) /* le fils lit le tube */
					printf("%c\n", car1);
				close(tube[0]) ; /* fermer le tube en lecture*/ 
				exit (0);
			}
		default : {
				close(tube[0]); /* Le père ne lit pas */
				for (car1='a'; car1<='z'; car1++)
					write(tube[1], &car1, 1); ; /* Le père écrit des lettres dans le tube */
				close(tube[1]); /*fermer le tube en écriture */
				wait(&ret); /* Blocage en attente de la fin du fils */
				exit(0);
			 }
 	}
}
